#ifndef THERMOCONTROL_h
#define THERMOCONTROL_h

#include <Adafruit_MAX31865.h>

enum modes : uint8_t {OFF, AUTOMATIC, MANUAL, OVERFLOW};

class thermoControl {
  private:
    double *output_pwm;
    double *control_temp;
    double * actual_temp;
    double current_temp;
    double hysteresis;
    double max_pwr_threshold;
    int outMax;
    int outMin;
    int SampleInterval;
    unsigned long lastTime;
    bool isheating;
    modes OpMode;

  public:
    thermoControl(double*, double*, double*, modes);
    void nope();
    bool Compute();
    double Power();
    void Power(double);
    double Setpoint();
    void Setpoint(double);
    void SampleTime(int);
    void PowerLimits(double, double);
    void Hysteresis(double);
    void Hysteresis();
    void ThreshPWR(double);
    void ThreshPWR();
    void Mode(modes);
    modes Mode();
    modes CycleMode();
};

#endif
